#!/usr/local/bin/perl

use File::Basename;
use Getopt::Long;

#
# table
#

%isdb_s_table = (
    '151' =>  0|&slot(0),	# 151chBSī
    '161' =>  0|&slot(1),	# 161chBS-TBS
    '191' =>  1|&slot(0),	# 191chWOWOWץ饤
    '171' =>  1|&slot(1),	# 171chBSѥ
    '192' =>  2|&slot(0),	# 192chWOWOW饤
    '193' =>  2|&slot(1),	# 193chWOWOWͥ
    '201' =>  3|&slot(0),	# 201chͥ2
    '202' =>  3|&slot(0),	# 202chͥ3
    '236' =>  3|&slot(1),	# 236chBS˥ޥå
    '256' =>  3|&slot(2),	# 256chǥˡͥ
    '211' =>  4|&slot(0),	# 211chBS11ǥ
    '200' =>  4|&slot(1),	# 200chͥ1
    '222' =>  4|&slot(2),	# 222chTwellV
    '238' =>  5|&slot(0),	# 238chFOX bs238
    '241' =>  5|&slot(1),	# 241chBSѡ!
    '231' =>  5|&slot(2),	# 231chBS1
    '232' =>  5|&slot(2),	# 232chBS2
    '233' =>  5|&slot(2),	# 233chBS3
    '531' =>  5|&slot(2),	# 531chإ饸
    '141' =>  6|&slot(0),	# 141chBSƥ
    '181' =>  6|&slot(1),	# 181chBSե
    '101' =>  7|&slot(0),	# 101chNHKBS1
    '102' =>  7|&slot(0),	# 102chNHKBS1׻
    '103' =>  7|&slot(1),	# 103chNHK BSץߥ
    '104' =>  7|&slot(1),	# 104chNHK BSץߥ׻
    '294' =>  8|&slot(1),	# 294chܥƥ
    '295' =>  8|&slot(1),	# 295chƥī
    '296' =>  8|&slot(1),	# 296chTBSƥ
    '297' =>  8|&slot(1),	# 297chƥ
    '291' =>  8|&slot(2),	# 291chNHK()
    '292' =>  8|&slot(2),	# 292chNHK
    '298' =>  8|&slot(2),	# 298chեƥ
    '234' =>  9|&slot(0),	# 234ch꡼ͥ
    '242' =>  9|&slot(1),	# 242chJ SPORTS 1
    '243' =>  9|&slot(2),	# 243chJ SPORTS 2
    '252' =>  10|&slot(0),	# 252chIMAGICA BS
    '244' =>  10|&slot(1),	# 244chJ SPORTS 3
    '245' =>  10|&slot(2),	# 245chJ SPORTS 4
    '251' =>  11|&slot(0),	# 251chBSӥ
    '255' =>  11|&slot(1),	# 255chܱǲͥ
    '258' =>  11|&slot(2),	# 258chD-Life

    # ND2
    'CS2' => 12|&slot(0),
    # 237chͥ ץ饹
    # 239chܱǲͥHD
    # 306chեƥNEXT

    # ND4
    'CS4' => 13|&slot(0),
    # 100che2ץ
    # 256chJ sports ESPN
    # 312chFOX
    # 322chڡTV
    # 331chȥͥåȥ
    # 294chۡɥޥͥ
    # 334chȥ󡦥ǥˡ

    # ND6
    'CS6' => 14|&slot(0),
    # 221chǥͥ
    # 222ch
    # 223chͥNECO
    # 224chβͥե롦ޥ
    # 292chͥ
    # 238chͥ 饷å
    # 310chѡɥTV
    # 311chAXN
    # 343chʥʥ른եåͥ

    # ND8
    'CS8' => 15|&slot(0),
    # 055chå ͥ
    # 335chåơHD

    # ND10
    'CS10'=> 16|&slot(0),
    # 228chͥ
    # 800chHD800
    # 801ch801
    # 802ch802

    # ND12
    'CS12'=> 17|&slot(0),
    # 260chաͥ
    # 303chƥīͥ
    # 323chMTV 324chͤβTVߥ塼å
    # 352chī˥塼
    # 353chBBCɥ˥塼
    # 354chCNNj
    # 110chƥݡ

    # ND14
    'CS14'=> 18|&slot(0),
    # 251chJ sports 1
    # 252chJ sports 2
    # 253chJ sports Plus
    # 254chGAORA
    # 255chAsports

    # ND16
    'CS16'=> 19|&slot(0),
    # 305chͥ
    # 333ch˥᥷X(AT-X)
    # 342chҥȥ꡼ͥ
    # 290chTAKARAZUKA SKYSTAGE
    # 803ch803
    # 804ch804

    # ND18
    'CS18'=> 20|&slot(0),
    # 240chࡼӡץ饹HD
    # 262chեͥåȥ
    # 314chLaLa HDHV

    #ND20
    'CS20'=> 21|&slot(0),
    # 258chեƥONE
    # 302chեƥTWO
    # 332ch˥ޥå
    # 340chǥХ꡼ͥ
    # 341ch˥ޥץͥå

    # ND22
    'CS22'=> 22|&slot(0),
    # 160chC-TBS륫ͥ
    # 161chQVC
    # 185chץ饤365.TV
    # 293chեߥ꡼
    # 301chTBSͥ
    # 304chǥˡͥ
    # 325chMUSIC ON! TV
    # 351chTBS˥塼С

    # ND24
    'CS24'=> 23|&slot(0),
    # 257chƥG+ HD
    # 291chfashiontv
    # 300chƥץ饹
    # 321chMusicJapan TV
    # 350chƥNEWS24
    # 362chιͥ
    );
%isdb_t_table = (
    "1"   =>   0,    "2"   =>   1,    "3"   =>   2,    "C13" =>   3,
    "C14" =>   4,    "C15" =>   5,    "C16" =>   6,    "C17" =>   7,
    "C18" =>   8,    "C19" =>   9,    "C20" =>  10,    "C21" =>  11,
    "C22" =>  12,    "4"   =>  13,    "5"   =>  14,    "6"   =>  15,
    "7"   =>  16,    "8"   =>  17,    "9"   =>  18,    "10"  =>  19,
    "11"  =>  20,    "12"  =>  21,    "C23" =>  22,    "C24" =>  23,
    "C25" =>  24,    "C26" =>  25,    "C27" =>  26,    "C28" =>  27,
    "C29" =>  28,    "C30" =>  29,    "C31" =>  30,    "C32" =>  31,
    "C33" =>  32,    "C34" =>  33,    "C35" =>  34,    "C36" =>  35,
    "C37" =>  36,    "C38" =>  37,    "C39" =>  38,    "C40" =>  39,
    "C41" =>  40,    "C42" =>  41,    "C43" =>  42,    "C44" =>  43,
    "C45" =>  44,    "C46" =>  45,    "C47" =>  46,    "C48" =>  47,
    "C49" =>  48,    "C50" =>  49,    "C51" =>  50,    "C52" =>  51,
    "C53" =>  52,    "C54" =>  53,    "C55" =>  54,    "C56" =>  55,
    "C57" =>  56,    "C58" =>  57,    "C59" =>  58,    "C60" =>  59,
    "C61" =>  60,    "C62" =>  61,    "C63" =>  62,    "13"  =>  63,
    "14"  =>  64,    "15"  =>  65,    "16"  =>  66,    "17"  =>  67,
    "18"  =>  68,    "19"  =>  69,    "20"  =>  70,    "21"  =>  71,
    "22"  =>  72,    "23"  =>  73,    "24"  =>  74,    "25"  =>  75,
    "26"  =>  76,    "27"  =>  77,    "28"  =>  78,    "29"  =>  79,
    "30"  =>  80,    "31"  =>  81,    "32"  =>  82,    "33"  =>  83,
    "34"  =>  84,    "35"  =>  85,    "36"  =>  86,    "37"  =>  87,
    "38"  =>  88,    "39"  =>  89,    "40"  =>  90,    "41"  =>  91,
    "42"  =>  92,    "43"  =>  93,    "44"  =>  94,    "45"  =>  95,
    "46"  =>  96,    "47"  =>  97,    "48"  =>  98,    "49"  =>  99,
    "50"  => 100,    "51"  => 101,    "52"  => 102,    "53"  => 103,
    "54"  => 104,    "55"  => 105,    "56"  => 106,    "57"  => 107,
    "58"  => 108,    "59"  => 109,    "60"  => 110,    "61"  => 111,
    "62"  => 112,
    );

sub slot
{
    my $n = shift;
    $n << 16;
}

sub usage
{
    my $m = shift;
    $m = ""
	unless defined $m;
    die <<_EOD_;
$m
usage: $0 [--b25 [--round N] [--strip] [--emm]] [--lnb V] [--sid X] channel duration filename
_EOD_
}

########################################

#
# parse option
#
GetOptions('b25' => \$opt{'b25'},
	   'round=i' => \$opt{'round'},
	   'strip' => \$opt{'strip'},
	   'emm' => \$opt{'emm'},

	   'lnb=i' => \$opt{'lnb'},	# not implement
	   'sid=s' => \$opt{'sid'}	# not implement
    ) or &usage;

#
if (defined $opt{'b25'}) {
    $cmdfmt = dirname($0) . "/b25";
    $cmdfmt = "b25"
	unless (-e $cmdfmt);

    $cmdfmt .= " -r " . $opt{'round'} if (defined $opt{'round'});
    $cmdfmt .= " -s 1" if (defined $opt{'strip'});
    $cmdfmt .= " -m 1" if (defined $opt{'emm'});
    $cmdfmt .= " -v 0 -p 0 %s %s";
} else {
    $cmdfmt = "/bin/cat %s > %s";
}

#
$channel = shift
    or &usage("no channel");
if (defined $isdb_t_table{$channel}) {
    $freq = $isdb_t_table{$channel};
    $tuner = 't';
} elsif (defined $isdb_s_table{$channel}) {
    $freq = $isdb_s_table{$channel};
    $tuner = 's';
}
defined($freq)
    or &usage("$channel: invalid channel");

$duration = shift
    or &usage("no duration");
$duration > 0
    or &usage("$duration: invalid duration");

$filename = shift
    or &usage("no filename");

#
# select device
#
#  TODO: multicard (/dev/ptx1, /dev/ptx2, ...)
#
open($t, "<", "/dev/ptx0.${tuner}0");
if ($t) {
    $dev = "/dev/ptx0.${tuner}0";
    $mib = "dev.ptx.0.${tuner}0";
} else {
    open($t, "<", "/dev/ptx0.${tuner}1");
    if ($t) {
	$dev = "/dev/ptx0.${tuner}1";
	$mib = "dev.ptx.0.${tuner}1";
    } else {
	die("device busy");
    }
}

#
# recording
#
system("/sbin/sysctl $mib.freq=$freq >/dev/null 2>&1");

eval {
    local $SIG{ALRM} = sub { die "alarm\n" };
    alarm $duration;

    $pid = fork();
    if ($pid) {
        close $t;
	wait;
    } else {
	$cmd = sprintf($cmdfmt, $dev, $filename);
        close $t;
	exec("$cmd");
    }

    alarm 0;
};

kill 2, $pid
    if ($pid);
wait;
